<template>
  <div>
      <!-- HEADER PARA EL HISTORIAL DEL CONTRATO -->
    <div style="margin:7rem 0 3rem">
      <el-header height="150px">
        <ReturnButton style="z-index: 234232" :offsetArrow="20" :spanTitle="3" title="Regresar" v-on:clickEvent="returnPage('confirmado', showContract)"> </ReturnButton>
        <el-row style="margin-top: 3rem" >
          <el-col :span="3" :offset="20"> 
            <el-button justify="end" type="primary" :disabled="statehistory === 'historial'">+ ADENDA</el-button>
          </el-col>
       </el-row>
      </el-header>
    </div>
        <!-- TITULO PARA HISTORIAL  -->
    <div style="margin: 4rem 9rem">
      <el-row :gutter="24" class="bg-dark-gray">
        <el-col :span="20">
          <el-card shadow="never" class="bg-dark-gray border-none title-views text-white"> HISTORIAL DEL CONTRATO </el-card>
        </el-col>       
      </el-row>
    </div>
    <div style="margin: 4rem 9rem" v-if="isHaveContractOriginalOrAdum(historySelected, 'contrato')">
      <h3 class="text-orange">CONTRATO ORIGINAL </h3>
    </div>
    <div style="margin: 4rem !important">
      
      <el-row class='grid-container'>
        <div v-if="isHaveContractOriginalOrAdum(historySelected, 'adenda')" class="bg-orange-ligth text-white" style="padding:7px 35px; margin-bottom:3rem">
          <p style="font-size:20px; font-weight:700">ADENDAS</p>
        </div>
        <el-col
          v-for="(contract, index) in historySelected"
          :key="index"
          style="margin-bottom: 4rem">          
          <el-card :body-style="{ padding: '0px' }" class="bg-gray">
            <el-row :gutter="20">
              <!-- Lado izquierdo -->
              <el-col :span="8" class="bg-white">
                <div class="text-orange" style="margin: 2rem 3rem; font-size:20px" v-if="contract.stateContrato !== 'CONTRATO ORIGINAL' ">{{contract.stateContrato}}</div>
                <div style="margin: 3rem 3rem 3rem">
                  <div class="title-styles" style="margin-bottom: 3rem">{{contract.contractName}}</div>
                  <div class="infoToShow__box">
                    <div style="margin: 18px auto; font-size: 18px">
                      <span class="infoToShow__title"><strong>Cod. Registro:</strong></span>
                      <span style="color: #8F8F8F">{{contract.contractCode}}</span>
                    </div>
                    <div style="margin: 18px auto; font-size: 18px">
                      <span class="infoToShow__title"><strong>Cod. Proveedor:</strong></span>
                      <span style="color: #8F8F8F">{{contract.providerCode}}</span>
                    </div>
                  </div>
                  <div v-if="contract.typeContract !== 'Afiliación'" class= "bg-orange-ligth font-general text-white subtitle-styles box-text1" style="margin-bottom: 1rem; padding: 5px 10px">Importe Total:
                    <span class="text-white">{{contract.currencySymbol}} {{contract.totalAmount}}</span>
                  </div>
                  <!-- vigencia -->
                  <el-table :data="historySelected[index].validity" size="medium" style="margin-top: 3rem" :header-cell-class-name="tableRowClassName">
                    <el-table-column label="VIGENCIA">
                      <el-table-column label="Inicio">
                       	<template slot-scope="scope">
                          <div style="margin-left: 10px" >
                            {{new Date( scope.row.startValidity ).toLocaleDateString('en-GB')}}
                          </div>
                        </template>
                      </el-table-column>
                      <el-table-column label="Fin" prop="validityEnd">
                      	<template slot-scope="scope">
                          <div style="margin-left: 10px">
                            <p>{{ new Date(scope.row.endValidity).toLocaleDateString('en-GB') }}</p>
                          </div>
                        </template>
                      </el-table-column>
                    </el-table-column>
                  </el-table>
                </div>
              </el-col>
              <!-- Lado derecho  -->
              <el-col :span="16">
                <div style= "margin: 1.5rem 3rem 1.5rem 2rem">
                  <div class="text-end">
                    <el-button v-if="contract.canceledStatus" class="border-grey-darken text-dark-gray-2" plain>CANCELADO</el-button>
                    <!-- <el-button v-if="contract.pendingStatus" class="border-orange text-orange" plain   @click='confirmedContractView(contract, "pendiente")' >PENDIENTE</el-button> -->
                    <el-button v-if="contract.confirmedStatus" class="border-green text-green" plain @click='confirmedContractView(contract, "prueba")' >CONFIRMADO</el-button>                 
                  </div>
                  <h3>MATERIALES</h3>
                  <p class="subtitle-styles" style="margin: 2rem 0">Total de Materiales: {{contract.admittedMaterials.length}}</p>
                  <!-- Relación de materiales -->
                  <div class="overflow-auto">
                    <el-row style="margin-bottom: 1rem" v-for="(item, index) in contract.admittedMaterials" :key="index">
                      <el-col :span="2">
                        <p style="padding: 5px 0" class="bg-dark-gray-2 text-white text-center">{{index + 1}}</p>
                      </el-col>
                      <el-col :span="21" :offset="1" class="bg-white">
                        <el-row >
                          <!-- :span="(contract.typeContract !== 'Afiliación')?11:16" -->
                          <el-col :span="11">
                            <p style="padding: 5px 0.8rem;">{{item.originalTitle}}</p>
                          </el-col>
                          <el-col :span="7">
                            <p class="bg-white text-material-type">({{contract.refMaterials[index].typeOfContent.substr(0,3)}})</p>
                          </el-col>
                           <!-- v-if="contract.typeContract !== 'Afiliación'" -->
                          <el-col :span="6">
                            <p style="padding: 5px 0.8rem;" class="text-orange" :class="(Object(item.numChapters).length > 0)?'fw-500': ''">
                              <span v-if="item.unitPrice !== 'Cortesía'">{{item.currencySymbol}}</span>
                              {{item.unitPrice}}
                            </p>
                          </el-col>
                        </el-row>
                         <!-- && contract.typeContract !== 'Afiliación' -->
                        <el-row v-if="Object(item.numChapters).length > 0" class="bg-white">
                          <el-row v-for="(tem, index) in item.numChapters" :key="index">
                            <el-col :span="11">
                              <el-row>
                                <el-col :span="12">
                                  <p style="padding: 5px 0.8rem;" class="f-15">
                                    <span class="fw-500">Temp.:</span> {{tem.season}}
                                  </p>
                                </el-col>
                                <el-col :span="12">
                                  <p style="padding: 5px 0.8rem;" class="f-15">
                                    <span class="fw-500">N° Cap:</span> {{tem.chapters}}
                                  </p>
                                </el-col>
                              </el-row>
                            </el-col>
                            <el-col :span="7">
                              <p style="padding: 5px 0.8rem; text-align: right;" class="f-15">Precio por Capítulo:</p> 
                            </el-col>
                            <el-col :span="6">
                              <!-- {{tem}} -->
                              <p style="padding: 5px 0.8rem;" class="text-orange f-15"> 
                                <span v-if="tem.chapterPrice !== 'Cortesía'">{{item.currencySymbol}}</span>
                                {{tem.chapterPrice}}
                              </p>
                            </el-col>
                            <hr style="border: 0.5px solid #eceaea" v-if="Object.keys(item.numChapters).length - 1 > index">
                          </el-row>
                        </el-row>
                      </el-col>
                      
                    </el-row>       
                  </div>
                  <p v-if="contract.typeContract !== 'Afiliación'" class="text-end" style="margin: 2rem 3rem 0 0"><strong>Importe Total: <span style="margin-left: 2rem">{{contract.currencySymbol}} {{contract.totalAmount}}</span></strong></p>
                </div>
              </el-col>
            </el-row>
          </el-card>
        </el-col>
      </el-row>
    </div>
  </div>    
</template>

<script>

import ReturnButton from '@/components/ReturnButton.vue'
import { mapState } from 'vuex'
  /**
  * @vue-data {Object} historySelected - La adenda con la informacion actual
  * @vue-data {String} statehistory - Validacion si ya tiene mas de una adenda
  * @vue-computed {String} stateContract - Estado del contrato si es adenda o no
  * @vue-computed {Object} showContract - Datos del contrato actual, sea adenda u original
  * @vue-computed {Object} copia - Datos del contrato original
  */
  export default {
    components: {
      ReturnButton,
    },
    data() {
      return {
        statehistory: JSON.parse(this.$localStorage.get("stateH")),
        historySelected: JSON.parse(this.$localStorage.get("contratoHistory")), // objeto de historial copia
        // stateContract: this.$store.state.contractStatus,
        // showContract: this.$store.state.setInContract,
        // copia: this.$store.state.setInContract
        // stateContract: JSON.parse(this.$localStorage.get("state")),
        // showContract: JSON.parse(this.$localStorage.get("aceptContract")), 
        // copia: JSON.parse(this.$localStorage.get("copiaContratoOriginal")),
      }  
    },
    methods: {
      /**
        * Valida si es el contrato original o una de las adendas de la lista
        * @param {Object} history - Los datos de la adenda o contrato original
        * @param {String} conditional - Cadena que filtra si es contrato original o adenda
        */
      isHaveContractOriginalOrAdum(history, conditional) {
        // console.log({history, conditional})
        let text = "CONTRATO ORIGINAL"
        let condition = conditional == 'adenda' ? `== ${text}` : `!== ${text}`
        let coincidence =  conditional == 'adenda' ? history.filter((e) => e.stateContrato !== `${text}`) : history.filter((e) => e.stateContrato == `${text}`)
        let result =  Boolean(coincidence.length)
        return result
      },
      returnPage(estado, contract) { // condicional para saber a que vista se va a redirigir 
       if(this.stateContract === 'prueba' || this.stateContract === 'confirmado') {
          // this.$localStorage.set('aceptContract', JSON.stringify(this.copia))
          this.$store.dispatch('setContract', this.copia)
          this.$router.push({ name: 'confirmedContract' })
       }
       else {
         this.$store.dispatch('setContractStatus', estado)
        //  this.$localStorage.set('state', JSON.stringify(estado)) 
         this.$router.push({ name: 'contract' })
       } 
      },
     tableRowClassName ({row, rowIndex}) {
        if (rowIndex === 0) {
          return 'first-row-header';
        }     
        if (rowIndex === 1) {
          return 'second-row-header';
        }
      },
      /**
        * Trae los datos de la adenda o el contrato en que se quiere ingresar para obternerlos desde el historial
        * @param {Object} contract - datos del contrato original o adenda seleccionada
        * @param {String} estado - Filtra el estado de la adenda o contrato
        */
      confirmedContractView(contract, estado) {
        this.$store.dispatch('setContract', contract)
        this.$store.dispatch('setContractStatus', estado)
        this.$router.push({name: 'confirmedContract' })
      },
    },
    computed: {
      ...mapState({
      stateContract: state => state.contractStatus,
      showContract: state => state.setInContract,
      copia: state => state.contractOriginal
    }),
    }
  }
</script>

<style scoped>
  .titleSection{
    background: #4A4A4A;
    color: white;
    padding: 10px 10px 10px 35px;
    text-transform: uppercase;
    font-weight: 400;
    margin: 40px auto;
    font-size: 18px;
  }
  .text-material-type{
    padding: 5px 0.8rem;
    color: #828282;
    text-transform: uppercase;
    text-align: right;
  }
  .f-15{
    font-size: 15px;
  }
  .fw-500{
    font-weight: 500;
  }
</style>


